$(document).ready(function() {
	var rotationAngle;
	var handle = $("#rotation-angle");
	$("#slider").slider({
		range : "min",
		min : 0,
		max : 360,
		create : function() {
			handle.text($(this).slider("value") + " deg");
		},
		slide : function(event, ui) {
		    $('#image').removeClass('rotate');
			rotationAngle = ui.value;
			handle.text(rotationAngle + " deg");
			rotate(rotationAngle);
		}
	});
	$('#btnSpin').on('click', function() {
		if ($(this).data('state') == 'off') {
			spin($(this));
		} else {
			stopSpin($(this));
		}
	});

	$('#btnRotate').on('click', function() {
		$('#image').removeClass('rotate');
		rotationAngle = $('#txtInputAngle').val();
		rotate(rotationAngle);
	});

	$('#btnRefresh').on('click', function() {
		$('#image').removeClass('rotate');
		rotate(0);
	});
});

function spin(buttonElement) {
	$('#image').addClass('rotate');
	$("#image").css("animation-play-state", "running");
	$(buttonElement).data('state', 'on');
	$(buttonElement).val('Stop');
}

function stopSpin(buttonElement) {
	$("#image").css("animation-play-state", "paused");
	$(buttonElement).data('state', 'off');
	$(buttonElement).val('Spin');
}

function rotate(rotationAngle) {
	if ($('#btnSpin').data('state') == 'on') {
		stopSpin($('#btnSpin'));
	}
	$('#image').css('transform', 'rotate(' + rotationAngle + 'deg)');
}
